
#include "AdapterInterface.h"

TGetIfTable pGetIfTable;

void * table;
DWORD size;

bool InitInterface (void)
{
   pGetIfTable=(TGetIfTable)GetProcAddress(LoadLibrary("Iphlpapi.dll"),"GetIfTable");
   if (pGetIfTable==NULL) return(false);
   pGetIfTable(NULL,&size,TRUE);              // zjisteni kolik bude potreba mista
   table=LocalAlloc(LMEM_FIXED,size);
   return(true);
}

void DestroyInterface (void)
{
   LocalFree(table);
}

void callGetTable (void)
{
   pGetIfTable((MIB_IFTABLE *)table,&size,TRUE);
}

int GetNumberOfAdapters (void)
{
   callGetTable();
   return(((MIB_IFTABLE *)table)->dwNumEntries);
}

MIB_IFROW getAdapterProperties (int number)
{
   callGetTable();
   return(((MIB_IFTABLE *)table)->table[number]);
}

void GetAdapterDescription (int number, char * desc)
{
   MIB_IFROW row=getAdapterProperties(number);
   row.bDescr[row.dwDescrLen]='\0';
   strcpy(desc,(char *)row.bDescr);
}

LONGLONG GetTrasmittedBytes (int number, DIRECTION dir)
{
   MIB_IFROW row=getAdapterProperties(number);
   return(dir==in?row.dwInOctets:row.dwOutOctets);
}