
#ifndef EVENTLIST_H__
#define EVENTLIST_H__

#include <string>
#include <vector>

class EventItem
{
   private:
      HWND hwnd;
      std::string text;
   public:
      EventItem (HWND h, const char * t) { hwnd=h; text=t; }
      const char * getText (void)        { return(text.c_str()); }
      HWND getHwnd (void)                { return(hwnd); }
};

class EventList
{
   private:
      std::vector <EventItem *> items;
   public:
      void clear (void)                  { items.clear(); }
      int getNumItems (void)             { return(items.size()); }
      void addItem (EventItem * item)    { items.insert(items.end(),item); }
      EventItem * getItem (void)         { return(items.size()?items[0]:NULL); }
      void removeItem (void)             { items.erase(items.begin()+0,items.begin()+0+1); }
};

#endif