
#ifndef  ACTIONLIST_H__
#define  ACTIONLIST_H__

#include <vector>
#include <time.h>

#define  A_POPUP       0
#define  A_RUN         1
#define  A_LOGOFF      2
#define  A_RESTART     3
#define  A_SUSPEND     4
#define  A_SHUTDOWN    5


class Action
{
   private:
      long        id;
      bool        active;
      short       type;
      int         day,month,year;
      int         hour,minute;
      std::string text,program,params;
   protected:
      time_t      hash;
      void countHash (void);
   public:
      Action (bool,short,int,int,int,int,int,const char *,const char *,const char *);
      long getID (void);
      time_t getHash (void);
      const char * getText (void);
      short getType (void);
      int getHour (void);
      int getMinute (void);
      int getDay (void);
      int getMonth (void);
      int getYear (void);
      const char * getProgram (void);
      const char * getParams (void);
      bool isActive (void);
      void setID (long);
      void setText (const char *);
      void setType (short);
      void setHour (int);
      void setMinute (int);
      void setDay (int);
      void setMonth (int);
      void setYear (int);
      void setProgram (const char *);
      void setParams (const char *);
      void setActive (bool);
      void toggleActive (void);
};


class ActionList 
{
   private:
      long availableID;
      std::vector <Action *> items;
   public:
      ActionList (void);
      int addObject (Action *);
      Action * getObject (int);
      void removeObject (int);
      void removeAll (void);
      int  getNumObjects (void);
      void sort (int *);
};

#endif