
#include "RSSReader.h"

/*RSSItem::RSSItem (const char * t, const char * l, const char * d)
{
   title=t==NULL?"":t;
   link=l;
   description=d==NULL?"":d;
}*/

RSSItem::RSSItem (void)
{
}

RSSItem::RSSItem (RSSItem * item)
{
   title=item->getTitle();
   link=item->getLink();
   description=item->getDescription();
}

RSSFeed::RSSFeed (const char * c, const char * u, bool e)
{
   caption=c;
   url=u;
   enabled=e;
   title="";
}

RSSFeed::RSSFeed (RSSFeed * sample)
{
   for (int n=0;n<sample->getNumItems();n++)
       addItem(new RSSItem(sample->getItem(n)));
}

RSSFeed::~RSSFeed ()
{
   clear();
}

void RSSFeed::clear (void)
{
   for (int i=0;i<items.size();i++) delete items[i];
   items.clear();
}

void RSSFeed::addItem (RSSItem * i)
{
   items.insert(items.end(),i);
};

int RSSFeed::getNumItems (void)
{
   return(items.size());
}

RSSItem * RSSFeed::getItem (int n)
{
   return(items[n]);
}

RSSItem * RSSFeed::getItemByUrl (const char * url)
{
   for (int n=0;n<items.size();n++)
       if (!strcmp(items[n]->getLink(),url)) return(items[n]);
 
   return(NULL);
}

void RSSFeed::setCaption (const char * c)
{
   caption=c;
}

void RSSFeed::setUrl (const char * u)
{
   url=u;
}

void RSSFeed::setTitle (const char * t)
{
   title=t==NULL?"":t;
}

void RSSFeed::setError (const char * t)
{
   title=caption+t;
}
void RSSFeed::setLink (const char * l)
{
   link=l;
}
void RSSFeed::setDescription (const char * d)
{
   description=d==NULL?"":d;
}



RSSReader::RSSReader ()
{
}

RSSReader::~RSSReader ()
{
   clear();
}

void RSSReader::clear (void)
{
   for (int n=0;n<getNumFeeds();n++) getFeed(n)->clear();
   feeds.clear();
}

void RSSReader::addFeed (RSSFeed * feed)
{
   feeds.insert(feeds.end(),feed);
}

RSSFeed * RSSReader::getFeedByUrl (const char * url)
{
   for (int n=0;n<getNumFeeds();n++) 
       if (!stricmp(url,feeds[n]->getUrl())) return(feeds[n]);

   return(NULL);
}

RSSFeed * RSSReader::getFeed (int n)
{
   return(feeds[n]);
}

char * RSSReader::UTF8ToAnsi (const char * utf8)
{
   if (utf8==NULL) return(NULL);

   WCHAR *unicode = NULL;
   int unicode_length=0;
   char *ascii=NULL;
   int ascii_length=0;

   unicode_length=MultiByteToWideChar(CP_UTF8,0,utf8,strlen(utf8),NULL,0);
   unicode=new WCHAR[unicode_length+1];
   memset(unicode,0,(unicode_length+1)*sizeof(WCHAR));
   MultiByteToWideChar(CP_UTF8,0,utf8,strlen(utf8),unicode,unicode_length);

   ascii_length=WideCharToMultiByte(CP_ACP,0,unicode,unicode_length,NULL,0,NULL, NULL);
   ascii=new char[ascii_length+1];
   memset(ascii,0,(ascii_length+1)*sizeof(char));
   WideCharToMultiByte(CP_ACP,0,unicode,unicode_length,ascii,ascii_length,NULL,NULL);

   delete unicode;
   return ascii;
}
