
#include "BBsky.h"

PLUGIN_STRUCT *plugin;

struct plugindata {
   bool       errorShout;
   bool       timerUpdate,reconfUpdate;
   long       timer;
   int        fontRise;
   int        title_x,title_y,icon_x,icon_y;
   int        titleAlign;
} plugindata;

UINT timer=0;
HANDLE thandle;
HFONT  titleFont,font;
bool thread_running=false;
HttpResponse * connection;

LocationList locations;
IconList icons;

const char * BBpluginCallback_InfoQuery (int field)
{
	switch (field) {
	       case PLUGIN_NAME:      return(szAppName);
          case PLUGIN_CLASSNAME: return(szClassName);
          case PLUGIN_VERSION:   return(szInfoVersion);  
          case PLUGIN_AUTHOR:    return(szInfoAuthor);   
          case PLUGIN_RELEASE:   return(szInfoRelDate); 
          case PLUGIN_LINK:      return(szInfoLink);   
          case PLUGIN_EMAIL:     return(szInfoEmail);   
          case PLUGIN_NAMEVER:   return(szVersion);
	}
   return(NULL);
}

bool BBpluginCallback_OnLoadPlugin()
{ 
   plugin=BBpluginExport_GetPlugin();

   return(true);
}

void BBpluginCallback_OnUnloadPlugin()
{
   KillTimer(NULL,timer);
   if (thread_running) {
      connection->shutDown();
      // wait for thread to terminate
      unsigned long ec;
      do {
         GetExitCodeThread(thandle,&ec);
         Sleep(10);
      } while (ec==STILL_ACTIVE);
   }
   if (titleFont) DeleteObject(titleFont);
}

bool BBpluginCallback_OnMessage (HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
   return(false);
}

void BBpluginCallback_OnBroam (const char * broam)
{
   if (BBplugin_IsBroam(&broam,TIMERUPDATE_COMMAND)) {
      plugindata.timerUpdate=!plugindata.timerUpdate;
   }
   if (BBplugin_IsBroam(&broam,FORCEUPDATE_COMMAND)) {
      StartDownloadThread();
   }
}

void BBpluginCallback_OnPaint (HDC hdc)
{
   Gdiplus::Graphics g(hdc);

   for (int l=0;l<locations.getNumLocations();l++) {
       Location *loc=locations.getLocation(l);
       const char *text=loc->getName();

       WCHAR string[WEATHER_MAX*2];
       MultiByteToWideChar(CP_ACP,0,text,-1,string,WEATHER_MAX*2);
      //Gdiplus::Font myFont(hdc,BBpluginExport_GetBB()->font);
       int left=loc->x+plugindata.title_x;
       Gdiplus::StringAlignment sa;
       switch (plugindata.titleAlign) {
              case ALIGN_CENTER: sa=Gdiplus::StringAlignmentCenter; left-=100; break;
              case ALIGN_LEFT:   sa=Gdiplus::StringAlignmentNear; break;
              case ALIGN_RIGHT:  sa=Gdiplus::StringAlignmentFar; left-=200; break;
       }
       Gdiplus::RectF rect(left,loc->y+plugindata.title_y,200,100);
       Gdiplus::Font tfont(hdc,titleFont);
       Gdiplus::StringFormat sf;
       sf.SetAlignment(sa);
      //MessageBox(0,"x",0,0);
       COLORREF c=plugin->windowStyleItem?plugin->windowStyleItem->TextColor:RGB(0,0,0);
       Gdiplus::SolidBrush brush(Gdiplus::Color(255,GetRValue(c),GetGValue(c),GetBValue(c)));
       g.DrawString(string,-1,&tfont,rect,&sf,&brush);

       Gdiplus::Font f(hdc,font);
       
       //  NAZEV MESTA
   //    HGDIOBJ oldfont=SelectObject(hdc,titleFont);
       /*SetRect(&rect,
               loc->x+plugin.title_x-100,
               loc->y+plugin.title_y,
               loc->x+plugin.title_x+100,
               loc->y+plugin.title_y+100);
       DrawText(hdc,loc->getName(),-1,&rect,DT_SINGLELINE|DT_TOP|plugin.titleAlign);*/
    //   SetTextAlign(hdc,TA_TOP | plugindata.titleAlign);
    //   TextOut(hdc,loc->x+plugindata.title_x,loc->y+plugindata.title_y,text,strlen(text));
   //    SelectObject(hdc,oldfont);

       
       //  IKONA POCASI
       Icon *icon=icons.getIconByID(loc->getSky());
       if (!icon) icon=icons.getIconByID(UNKNOWN_WEATHER);
       if (icon) {
          Gdiplus::Bitmap * bitmap=icon->getHandle();
          g.DrawImage(bitmap,loc->x+plugindata.icon_x,loc->y+plugindata.icon_y,
             bitmap->GetWidth(),bitmap->GetHeight());
       }




       loc->labels->paintLabels(g,loc->x,loc->y,f,brush);


       //for (int la=0;la<loc->labels->getNumLabels();la++) {
           
/*           Label *lab=loc->labels->getLabel(la);
           DrawState(hdc,0,0,
              (long)lab->getIcon(),
              0,
              loc->x+lab->left,
              loc->y+lab->y,
              0,0,DST_ICON);
           SetTextAlign(hdc,TA_TOP | TA_LEFT);
           text=lab->getCaption();
           TextOut(hdc,loc->x+lab->left+lab->xtab,loc->y+lab->y+lab->ytab,text,strlen(text));
           SetTextAlign(hdc,TA_TOP | TA_RIGHT);
           text=loc->labels->getLabel(la)->getContent();
           TextOut(hdc,loc->x+lab->right,loc->y+lab->y+lab->ytab,text,strlen(text));
           */
/*              SetRect(&rect,
                      loc->x+lab->left+lab->xtab,
                      loc->y+lab->y+lab->ytab,
                      loc->x+lab->left+100,
                      loc->y+lab->y+lab->ytab+20);
              DrawText(hdc,lab->getCaption(),-1,&rect,DT_TOP|DT_LEFT);
              SetRect(&rect,
                      loc->x+lab->right-100,
                      loc->y+lab->y+lab->ytab,
                      loc->x+lab->right,
                      loc->y+lab->y+lab->ytab+20);
              DrawText(myDC,loc->labels->getLabel(la)->getContent(),-1,&rect,DT_TOP|DT_RIGHT);*/
       //} 
   }
}

bool BBpluginCallback_OnCreateMenu (Menu * menu)
{
   char broam[1000];
   const char *broam_prefix=BBpluginExport_GetBroamPrefix();

   sprintf(broam,"%s%s",broam_prefix,TIMERUPDATE_COMMAND);
   MakeMenuItem(menu,"Timer Update",broam,plugindata.timerUpdate);
   sprintf(broam,"%s%s",broam_prefix,FORCEUPDATE_COMMAND);
   MakeMenuItem(menu,"Force Update!",broam,false);

   return(true);
}

void BBpluginCallback_OnConfigure (void)
{
   icons.clear();
   locations.clear();

   plugindata.timer=BBplugin_ReadInt("timer",60)*1000L*60L;
   plugindata.errorShout=BBplugin_ReadBool("errorShout",true);
   plugindata.timerUpdate=BBplugin_ReadBool("timerUpdate",true);
   plugindata.reconfUpdate=BBplugin_ReadBool("reconfigureUpdate",false);

   plugindata.title_x=BBplugin_ReadInt("titleCaption.x",0);
   plugindata.title_y=BBplugin_ReadInt("titleCaption.y",0);
   plugindata.icon_x=BBplugin_ReadInt("titleIcon.x",0);
   plugindata.icon_y=BBplugin_ReadInt("titleIcon.y",0);
   plugindata.fontRise=BBplugin_ReadInt("titleFontRise",0);
   const char *align=BBplugin_ReadString("titleAlign","center");
   plugindata.titleAlign=ALIGN_CENTER;
   if (!stricmp(align,"left")) plugindata.titleAlign=ALIGN_LEFT;
   if (!stricmp(align,"right")) plugindata.titleAlign=ALIGN_RIGHT;

   int icos=BBplugin_ReadInt("icons.iconCount",0);
   char strI[]="icons.icon";
   for (int ico=1;ico<=icos;ico++) {
       char str1[100],str2[100];
       sprintf(str1,"%s[%d].id",strI,ico);
       sprintf(str2,"%s[%d].path",strI,ico);
       //icons.addIcon(new Icon(BBplugin_ReadString(str1,""),BBplugin_LoadIcon(BBplugin_ReadString(str2,NULL))));
       Gdiplus::Bitmap * bitmap=BBplugin_LoadImage(BBplugin_ReadString(str2,NULL));
       if (bitmap) icons.addIcon(new Icon(BBplugin_ReadString(str1,""),bitmap));
   }

   int lbls=BBplugin_ReadInt("labels.labelCount",0);
   LabelList *labels=new LabelList();;
   for (int lbl=1;lbl<=lbls;lbl++) {
       char str[100];
       sprintf(str,"labels.label[%d]",lbl);
       labels->addLabel(new Label(str));
   }

   int locs=BBplugin_ReadInt("locations",0);
   char strL[]="location";
   for (int loc=1;loc<=locs;loc++) {
       char str[100],str1[100],str2[100];
       int x,y;
       sprintf(str,"%s[%d].x",strL,loc);
       x=BBplugin_ReadInt(str,0);
       sprintf(str,"%s[%d].y",strL,loc);
       y=BBplugin_ReadInt(str,0);
       sprintf(str,"%s[%d].name",strL,loc);
       sprintf(str1,"%s[%d].url",strL,loc);
       sprintf(str2,"%s[%d].definition",strL,loc);
       Location *location=
          new Location(
             x,y,
             BBplugin_ReadString(str,""),
             BBplugin_ReadString(str1,""),
             BBplugin_ReadString(str2,"")
          );
       // prvni lokace dostane jiz vytvorene labely, dalsi dostanou klony
       location->labels=(loc==1)?labels:new LabelList(labels);
       locations.addLocation(location);
   }

   font=BBpluginExport_GetBB()->font;

   LOGFONT logFont;
   ZeroMemory(&logFont,sizeof(LOGFONT));
   GetObject(font,sizeof(font),&logFont);
   logFont.lfHeight+=plugindata.fontRise;
   logFont.lfWeight=FW_BOLD;
   if (titleFont) DeleteObject(titleFont);
   titleFont=CreateFontIndirect(&logFont);

   if (timer) KillTimer(NULL,timer);
   timer=SetTimer(NULL,NULL,plugindata.timer,(TIMERPROC)TimerProc);

   if (plugindata.reconfUpdate) StartDownloadThread();
}

void BBpluginCallback_OnSaveConfiguration (void)
{
    BBplugin_WriteBool("timerUpdate",plugindata.timerUpdate);
}


TIMERPROC TimerProc (void)
{
   if (plugindata.timerUpdate) StartDownloadThread();

   return(0);
}

void StartDownloadThread (void)
{
   if (!thread_running) {
      thandle=CreateThread(NULL,0,DownloadThread,0,0,0);
   }
}

DWORD WINAPI DownloadThread (LPVOID)
{
   thread_running=true;
   HttpResponse response;
   connection=&response;

   for (int loc=0;loc<locations.getNumLocations();loc++) {       
       Location *location=locations.getLocation(loc);

       int respCode=response.grab_www(location->getUrl(),"User-Agent: BBsky@BB4Win\r\n");
       if (respCode!=RESPONSE_OK) {
          if (plugindata.errorShout && respCode!=RESPONSE_SHUTDOWN)
             MessageBox(BBpluginExport_GetBB()->hwnd,location->getUrl(),"Error downloading",MB_OK|MB_ICONERROR|MB_SETFOREGROUND);          
          thread_running=false;
          return(1);
       }
       
       long size;
       char *buffer=(char *)response.getContentData(&size);

/*       char file[1000]; 
       sprintf(file,"%sdump%d.txt",BBpluginExport_GetPlugin()->directory,loc);
       FILE * fp=fopen(file,"w+b");
       if (fp==NULL) MessageBox(0,"err",0,0);
       long s;
       void *d=response.getData(&s);
       fwrite(d,s,1,fp);
       fclose(fp);*/

       removeControlChars(buffer,size);

       char defs[MAX_PATH];
       strcpy(defs,plugin->directory);
       strcpy(defs+strlen(plugin->directory),location->getDefFile());
  
       TokenList tokens;
       int tocs=ReadInt(defs,"define.tokenCount:",0);
       char strT[]="define.token";
       for (int t=1;t<=tocs;t++) {
           char str1[100],str2[100];
           sprintf(str1,"%s[%d].id:",strT,t);
           sprintf(str2,"%s[%d].regexp:",strT,t);
           tokens.addToken(new Token(ReadString(defs,str1,""),ReadString(defs,str2,"")));
       }

       for (int la=0;la<location->labels->getNumLabels();la++) {
           Label *label=location->labels->getLabel(la);
           Token *token=tokens.getTokenByID(label->getID());
           if (token) 
              parseValue(buffer,label->getContentPtr(),token->getRegexp());
       }

       WeatherList weathers;
       int weaths=ReadInt(defs,"define.weatherCount:",0);
       char str[]="define.weather";
       for (int w=1;w<=weaths;w++) {
           char str1[100],str2[100];
           sprintf(str1,"%s[%d].iconID:",str,w);
           sprintf(str2,"%s[%d].keyword:",str,w);
           weathers.addWeather(new Weather(ReadString(defs,str1,""),ReadString(defs,str2,"")));
       }

       char weatherStr[WEATHER_MAX];
       Token *main=tokens.getTokenByID(MAIN_TOKEN);
       if (main) {
          parseValue(buffer,weatherStr,main->getRegexp());
 
          location->setSky(UNKNOWN_WEATHER);
          for (w=0;w<weathers.getNumWeathers();w++) {
              Weather *weather=weathers.getWeather(w);
              if (!strcmp(weather->getKeyword(),weatherStr)) {   // keyword sedi
                 Icon *icon=icons.getIconByID(weather->getIconID());
                 if (icon) location->setSky(icon->getID());
              }
          }
       }

       BBpluginExport_Repaint();
   }
    
   thread_running=false;
   return(0);
}

bool parseValue (char *buffer, char *result, LPCSTR regexp)
{
   ZeroMemory(result,WEATHER_MAX);

   // trex_compile pada pri pattern=="" i NULL
   if (regexp==NULL) return(false);

   const char *error;
   TRex *x=trex_compile(regexp,&error);
   if (x) {
      const char *begin, *end;
      if (trex_search(x,buffer,&begin,&end)) {
         TRexMatch match;
         trex_getsubexp(x,1,&match);
         strncpy(result,match.begin,match.len);
         return(true);
      }
   }
   return(false);
}

void removeControlChars (char * buffer, long size)
{
   int j=0;
   for (int i=0;i<size;i++) // tady to obcas pretece buffer!!!
       if (buffer[i]<32) j++;
       else buffer[i-j]=buffer[i];
   if (size!=0) buffer[i-j]='\0';
}
/*
char * toLower (char * buffer)
{
   for (int i=0;buffer[i]!='\0';i++) buffer[i]=tolower(buffer[i]);
   return(buffer);
}*/

