
#ifndef SYSTEMMONITOR_H__
#define SYSTEMMONITOR_H__

#include <windows.h>

typedef struct 
{
	LARGE_INTEGER liKeBootTime;
	LARGE_INTEGER liKeSystemTime;
	LARGE_INTEGER liExpTimeZoneBias;
	ULONG uCurrentTimeZoneId;
	DWORD dwReserved;
} SYSTEM_TIME_INFORMATION;

typedef struct
{
	LARGE_INTEGER liIdleTime;
	DWORD dwSpare[76];
}  SYSTEM_PERFORMANCE_INFORMATION;

typedef struct 
{
	DWORD dwUnknown1;
	ULONG uKeMaximumIncrement;
	ULONG uPageSize;
	ULONG uMmNumberOfPhysicalPages;
	ULONG uMmLowestPhysicalPage;
	ULONG uMmHighestPhysicalPage;
	ULONG uAllocationGranularity;
	PVOID pLowestUserAddress;
	PVOID pMmHighestUserAddress;
	ULONG uKeActiveProcessors;
	BYTE bKeNumberProcessors;
	BYTE bUnknown2;
	WORD wUnknown3;
} SYSTEM_BASIC_INFORMATION;

typedef BOOL (__stdcall *NTQUERYSYSTEMINFORMATION) (
   DWORD SystemInformationClass, 
   PVOID SystemInformation, 
   ULONG SystemInformationLength, 
   PULONG ReturnLength);


bool InitSystemMonitor (void);
void DestroySystemMonitor (void);
int GetCPULoad();
__int64 GetDiskFreeSpace (const char *);
void GetLocalIP (char *);
void GetMemoryStatus (DWORD *, DWORD *, DWORD *) ;
void GetPowerStatus (bool *, bool *, bool *, int *);
void GetSystemTime (int *, int *);

#endif