
#include "BBwincolors.h"

char stylepath[MAX_PATH];
COLORS oldC, newC;


static int winFields[PREDEFINED_COLORS]={
   /*  0 */ COLOR_3DDKSHADOW,               // dark shadow
   /*  1 */ COLOR_3DFACE,                   // plocha okna
   /*  2 */ COLOR_3DHIGHLIGHT,              // okraj 3d: svetlejsi
   /*  3 */ COLOR_3DLIGHT,                  // svetlo dopadajici na levy horni okraj
   /*  4 */ COLOR_3DSHADOW,                 // okraj 3d: tmavejsi
   /*  5 */ COLOR_ACTIVEBORDER,             // okraj aktivniho okna
   /*  6 */ COLOR_ACTIVECAPTION,            // titulkovy pruh aktivniho okna
   /*  7 */ COLOR_APPWORKSPACE,             // podklad pro vicedokumentove aplikace
   /*  8 */ COLOR_BACKGROUND,
   /*  9 */ COLOR_BTNTEXT,                  // text cudliku
   /* 10 */ COLOR_CAPTIONTEXT,              // barva textu
   /* 11 */ COLOR_GRADIENTACTIVECAPTION,    // prava strana
   /* 12 */ COLOR_GRADIENTINACTIVECAPTION,  // prava strana
   /* 13 */ COLOR_GRAYTEXT,                 // zasedla polozka
   /* 14 */ COLOR_HIGHLIGHT,                // aktualni polozka v menu
   /* 15 */ COLOR_HIGHLIGHTTEXT,            // text aktualni polozky v menu
   /* 16 */ COLOR_HOTLIGHT,
   /* 17 */ COLOR_INACTIVEBORDER,           // okraj neaktivniho okna
   /* 18 */ COLOR_INACTIVECAPTION,          // titulkovy pruh neaktivniho okna
   /* 19 */ COLOR_INACTIVECAPTIONTEXT,      // barva textu
   /* 20 */ COLOR_INFOBK,                   // pozadi tooltipu
   /* 21 */ COLOR_INFOTEXT,                 // text tooltipu
   /* 22 */ COLOR_MENU,                     // pozadi menu
   /* 23 */ 29,
   /* 24 */ 30,
   /* 25 */ COLOR_MENUTEXT,                 // text menu
   /* 26 */ COLOR_SCROLLBAR,
   /* 27 */ COLOR_WINDOW,                   // barva okna (plocha editu...)
   /* 28 */ COLOR_WINDOWFRAME,              // ohraniceni aktualniho buttonu
   /* 29 */ COLOR_WINDOWTEXT                // barva pisma (pismo editu...)
};


LPCSTR winFieldsStr[PREDEFINED_COLORS]={
   "COLOR_3DDKSHADOW",
   "COLOR_3DFACE",
   "COLOR_3DHIGHLIGHT",
   "COLOR_3DLIGHT",
   "COLOR_3DSHADOW",
   "COLOR_ACTIVEBORDER",
   "COLOR_ACTIVECAPTION",
   "COLOR_APPWORKSPACE",
   "COLOR_BACKGROUND",
   "COLOR_BTNTEXT",
   "COLOR_CAPTIONTEXT",
   "COLOR_GRADIENTACTIVECAPTION",
   "COLOR_GRADIENTINACTIVECAPTION",
   "COLOR_GRAYTEXT",
   "COLOR_HIGHLIGHT",
   "COLOR_HIGHLIGHTTEXT",
   "COLOR_HOTLIGHT",
   "COLOR_INACTIVEBORDER",
   "COLOR_INACTIVECAPTION",
   "COLOR_INACTIVECAPTIONTEXT",
   "COLOR_INFOBK",
   "COLOR_INFOTEXT",
   "COLOR_MENU",
   "COLOR_MENUHILIGHT",
   "COLOR_MENUBAR",
   "COLOR_MENUTEXT",
   "COLOR_SCROLLBAR",
   "COLOR_WINDOW",
   "COLOR_WINDOWFRAME",
   "COLOR_WINDOWTEXT"
};

#define     f_color        1
#define     f_colorTo      2
#define     f_textColor    3

static int bbFields[PREDEFINED_COLORS][2]={
   /*  0 */ { SN_MENUTITLE, f_color },
   /*  1 */ { SN_MENUFRAME, f_color },
   /*  2 */ { SN_MENUFRAME, f_color },
   /*  3 */ { SN_MENUTITLE, f_color },
   /*  4 */ { SN_WINUNFOCUS_LABEL, f_color },
   /*  5 */ { SN_MENUFRAME, f_colorTo },
   /*  6 */ { SN_WINFOCUS_LABEL, f_color },
   /*  7 */ { SN_TOOLBAR, f_color },
   /*  8 */ { -1, -1 },
   /*  9 */ { SN_MENUFRAME, f_textColor },
   /* 10 */ { SN_WINFOCUS_LABEL, f_textColor },
   /* 11 */ { SN_WINFOCUS_LABEL, f_colorTo },
   /* 12 */ { SN_WINUNFOCUS_LABEL, f_colorTo },
   /* 13 */ { SN_TOOLBARWINDOWLABEL, f_textColor },
   /* 14 */ { SN_TOOLBARWINDOWLABEL, f_colorTo },
   /* 15 */ { SN_TOOLBARWINDOWLABEL, f_textColor },
   /* 16 */ { -1, -1 },
   /* 17 */ { SN_WINUNFOCUS_LABEL, f_color },
   /* 18 */ { SN_WINUNFOCUS_LABEL, f_color },
   /* 19 */ { SN_WINUNFOCUS_LABEL, f_textColor },
   /* 20 */ { SN_TOOLBARWINDOWLABEL, f_colorTo },
   /* 21 */ { SN_TOOLBARWINDOWLABEL, f_textColor },
   /* 22 */ { SN_MENUFRAME, f_color },
   /* 23 */ { -1, -1 },
   /* 24 */ { -1, -1 },
   /* 25 */ { SN_MENUFRAME, f_textColor },
   /* 26 */ { -1, -1 },
   /* 27 */ { SN_TOOLBAR, f_color },
   /* 28 */ { SN_TOOLBARWINDOWLABEL, f_color },
   /* 29 */ { SN_TOOLBAR, f_textColor }
};


const char * BBpluginCallback_InfoQuery (int field)
{
	switch (field) {
	       case PLUGIN_NAME:      return(szAppName);
          case PLUGIN_CLASSNAME: return(szClassName);
          case PLUGIN_VERSION:   return(szInfoVersion);  
          case PLUGIN_AUTHOR:    return(szInfoAuthor);   
          case PLUGIN_RELEASE:   return(szInfoRelDate); 
          case PLUGIN_LINK:      return(szInfoLink);   
          case PLUGIN_EMAIL:     return(szInfoEmail);   
          case PLUGIN_NAMEVER:   return(szVersion);
	}
   return(NULL);
}

bool BBpluginCallback_OnLoadPlugin()
{ 
   ShowWindow(BBpluginExport_GetPlugin()->hwnd,SW_HIDE);

   return(true);
}

void BBpluginCallback_OnUnloadPlugin()
{
   setWindowsColors(&oldC);
}

bool BBpluginCallback_OnMessage (HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
   return(false);
}

void BBpluginCallback_OnBroam (const char * broam)
{
}

void BBpluginCallback_OnPaint (HDC hdc)
{
}

bool BBpluginCallback_OnCreateMenu (Menu * menu)
{
   return(false);
}

void BBpluginCallback_OnConfigure (void)
{
   getWindowsColors(&oldC);

   memset(&newC,0,sizeof(COLORS));

   strcpy(stylepath,stylePath());
   LPCSTR loadtype=ReadString(stylepath,szAppName".load:","plugin");

   // nastavi barvy jak by to udelal sam plugin
   if (!stricmp(loadtype,"plugin")) {
      retrieveBBColors(&newC);
   }
   // nastavi barvy jak jsou napsane ve stylu
   if (!stricmp(loadtype,"style")) {
      retrieveStyleColors(&newC);
   }
   // nastavi barvy jak by to udelal sam plugin a pres ne jeste barvy stylu
   if (!stricmp(loadtype,"override")) {
      retrieveBBColors(&newC);
      COLORS tempC;
      retrieveStyleColors(&tempC);
      combineColors(&newC,&tempC);
   }

   setWindowsColors(&newC);   
}

void BBpluginCallback_OnSaveConfiguration (void)
{
}


void getWindowsColors (COLORS * cols) {
   for (int i=0;i<PREDEFINED_COLORS;i++) {
       cols->color[i].val=GetSysColor(winFields[i]);
       cols->color[i].def=true;
   }
}
void setWindowsColors (COLORS * cols)
{
   // protoze delat to v cyklu je pomale a blika to, vytvorime pomocne pole
   // a udelame to najednou
   COLORREF tmpc[PREDEFINED_COLORS];
   for (int i=0;i<PREDEFINED_COLORS;i++) {
       tmpc[i]=cols->color[i].def?cols->color[i].val:oldC.color[i].val;
       //if (cols->color[i].def) MessageBox(0,"def",0,0);
   }
   SetSysColors(PREDEFINED_COLORS,&winFields[0],&tmpc[0]);
}

void retrieveBBColors (COLORS * cols)
{
   for (int i=0;i<PREDEFINED_COLORS;i++) {
       if (bbFields[i][0]!=-1) {
          StyleItem *si=(StyleItem *)GetSettingPtr(bbFields[i][0]);
          switch (bbFields[i][1]) {
                 case f_color: cols->color[i].val=si->Color; break;
                 case f_colorTo: cols->color[i].val=si->ColorTo; break;
                 case f_textColor: cols->color[i].val=si->TextColor; break;
          }
       }
       cols->color[i].def=bbFields[i][0]!=-1;
   }
}

void retrieveStyleColors (COLORS * cols)
{
   for (int i=0;i<PREDEFINED_COLORS;i++) {
       char str[100];
       sprintf(str,"%s.\"%s\":",szAppName,winFieldsStr[i]);
       cols->color[i].val=ReadColor(stylepath,str,NULL);
       cols->color[i].def=FoundLastValue()==1;
       //if (cols->color[i].def) MessageBox(0,str,0,0);
   }
}

void combineColors (COLORS * cols, COLORS * cols2)
{
   for (int i=0;i<PREDEFINED_COLORS;i++) {
       if (cols2->color[i].def)
          cols->color[i]=cols2->color[i];
   }
}